Index: apps/app_festival.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_festival.c,v
retrieving revision 1.12
diff -u -r1.12 app_festival.c
--- apps/app_festival.c	11 Jan 2004 08:32:50 -0000	1.12
+++ apps/app_festival.c	18 Jan 2004 17:16:01 -0000
@@ -46,9 +46,9 @@
 static char *synopsis = "Say text to the user";
 
 static char *descrip = 
-"  Festival(text[|intkeys]):  Connect to Festival, send the argument, get back the waveform,"
-"play it to the user, allowing any given interrupt keys to immediately terminate and return\n"
-"the value, or 'any' to allow any number back (useful in dialplan)\n";
+"  Festival(text[|intkeys]):  Answer channel if not already done.  Connect to Festival, \nsend the " 
+"argument, get back the waveform, play it to the user, allowing any \ngiven interrupt keys to"
+"immediately terminate and return the value, or 'any' \nto allow any number back (useful in dialplan)\n";
 
 STANDARD_LOCAL_USER;
 
@@ -106,6 +106,7 @@
 
         int res;
         int x;
+	char *pad[8000];
 #ifdef __PPC__ 
 	char c;
 #endif
@@ -119,7 +120,10 @@
                 if (x != fd)
                         close(x);
         }
-//IAS
+
+	memset( pad, 0, 8000);
+	write(fd, pad, 8000);
+
 #ifdef __PPC__  
 	for( x=0; x<length; x+=2)
 	{
@@ -128,7 +132,6 @@
 		*(waveform+x)=c;
 	}
 #endif
-	
 	write(fd,waveform,length);
 	write(fd,"a",1);
 	close(fd);
@@ -315,6 +318,14 @@
 			intstr = AST_DIGIT_ANY;
 	}
 	LOCAL_USER_ADD(u);
+	if (chan->_state != AST_STATE_UP) {
+		res = ast_answer(chan);
+		if( res) {
+			ast_log(LOG_WARNING, "Unable to answer channel\n");
+			return -1;
+		}
+	}
+
 	ast_log(LOG_DEBUG, "Text passed to festival server : %s\n",(char *)data);
 	/* Connect to local festival server */
 	
